<script setup lang="ts">
    import { RouteRecordRaw, useRouter } from 'vue-router'
    import { useDisplay } from 'vuetify'
    import { ref } from 'vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import {
        ServiceOffer,
        ServiceOfferNamespaces,
    } from '@/serviceOffer/entities/serviceOffer/ServiceOffer'
    import { requireValue } from '@/shared/helpers/types'

    export interface Props {
        pageTitle: string
        serviceOfferType: keyof typeof ServiceOfferNamespaces
        serviceOfferId: ServiceOffer['id'] | undefined
        pageIsLoading?: boolean
        showTitle?: boolean
    }

    const props = withDefaults(defineProps<Props>(), {
        showTitle: true,
        pageIsLoading: false,
    })

    const router = useRouter()
    const menuRoutes: RouteRecordRaw[] = requireValue(
        router
            .getRoutes()
            .find(
                (routeRecord) =>
                    routeRecord.meta.node ===
                    `${props.serviceOfferType}/admin-root-route`
            )?.children
    )

    const { mobile } = useDisplay()
    const isDrawerOpen = ref(!mobile.value)
</script>

<template>
    <s-contextual-navbar
        :page-title="$props.pageTitle"
        :show-title="$props.showTitle"
        :page-is-loading="props.pageIsLoading"
    >
        <template #contextualButtons>
            <slot name="searchField"></slot>
            <v-btn
                v-if="mobile"
                icon="mdi-menu"
                color="on-background"
                data-cy="btn-silab-admin-toggle-menu"
                @click="isDrawerOpen = !isDrawerOpen"
            ></v-btn>
        </template>
    </s-contextual-navbar>
    <v-navigation-drawer v-model="isDrawerOpen" :permanent="!mobile">
        <v-list v-if="serviceOfferType && serviceOfferId">
            <v-list-item
                v-for="route in menuRoutes"
                :key="route.path"
                :data-cy="`btn-silab-admin-menu-item-${
                    route.name?.toString() ?? ''
                }`"
                variant="text"
                :value="route.name"
                :prepend-icon="route.meta?.icon as string | undefined"
                :active="$router.currentRoute.value.name === route.name"
                @click="
                    router.push({
                        name:
                            route.name ?? (route.meta?.indexViewName as string),
                        params: {
                            serviceOfferType:
                                ServiceOfferNamespaces[serviceOfferType],
                            serviceOfferId: serviceOfferId,
                        },
                    })
                "
            >
                {{ route.meta?.title }}
            </v-list-item>
        </v-list>
    </v-navigation-drawer>
</template>
